<HTML>
<HEAD>
<!-- This HTML file has been created by texi2html 1.54
     from suif1.texi on 28 April 1999 -->

<TITLE>The SUIF Version 1 Library - Generic Instructions</TITLE>
<link href="suif1_40.html" rel=Next>
<link href="suif1_38.html" rel=Previous>
<link href="suif1_toc.html" rel=ToC>

</HEAD>
<BODY>
<p>Go to the <A HREF="suif1_1.html">first</A>, <A HREF="suif1_38.html">previous</A>, <A HREF="suif1_40.html">next</A>, <A HREF="suif1_113.html">last</A> section, <A HREF="suif1_toc.html">table of contents</A>.
<P><HR><P>


<H2><A NAME="SEC39" HREF="suif1_toc.html#TOC39">Generic Instructions</A></H2>
<P>
<A NAME="IDX254"></A>
<A NAME="IDX255"></A>

</P>
<P>
<A NAME="IDX256"></A>
To help support special-purpose extensions to SUIF, we have provided a
generic class of instructions.  This is implemented in the <CODE>in_gen</CODE>
class.  These generic instructions contain arbitrarily large arrays of
source operands and a character string field to hold user-defined names
that function as "sub-opcodes".  Generic instructions are not part of
standard SUIF and most SUIF passes will not handle them.

</P>
<P>
<A NAME="IDX257"></A>
<A NAME="IDX258"></A>
Because it is difficult to add new opcodes to SUIF at run-time, the
generic instructions all share the same <CODE>gen</CODE> opcode.  Instead,
they are distinguished by user-defined names.  The <CODE>name</CODE> and
<CODE>set_name</CODE> methods may be used to access these character string
fields.  The <CODE>set_name</CODE> method automatically enters the name in the
lexicon (see section <A HREF="suif1_102.html#SEC102">Lexicon</A>).

</P>
<P>
<A NAME="IDX259"></A>
A generic instruction contains a pointer to an array of source operands.
The base class <CODE>num_srcs</CODE> method may be used to determine the size
of this array.  The size may be changed at any time using the
<CODE>set_num_srcs</CODE> method.  If necessary, the array will be
reallocated.  The elements of the source operand array can be accessed
using the standard base class <CODE>src_op</CODE> and <CODE>set_src_op</CODE>
methods.  See section <A HREF="suif1_28.html#SEC28">Source Operands</A>.

</P>

<P><HR><P>
<p>Go to the <A HREF="suif1_1.html">first</A>, <A HREF="suif1_38.html">previous</A>, <A HREF="suif1_40.html">next</A>, <A HREF="suif1_113.html">last</A> section, <A HREF="suif1_toc.html">table of contents</A>.
</BODY>
</HTML>
